#include <stdio.h>
#include <stdlib.h>
#include <math.h>
//
typedef struct{
	double x, y;
} Point;

typedef struct{
   Point *array;
   int size;
} Stack;

//
void initStack(Stack *stack);
//
void printStack(Stack *stack);
//
int getStackSize(Stack *stack);
//
void push(Stack *stack, double a, double b);
//
Point top(Stack *stack);
//
Point pop(Stack *stack);
//
void destroyStack(Stack *stack);
//
int main ()
{
	//Testing
	Stack stack;
	initStack (&stack);
   push(&stack, 4.0, 3.0);
   push(&stack, 8.0, 3.0);
   push(&stack, -13, 2);
   push(&stack, 700, 7.5);
   push(&stack, -5, 1.5);
   printStack(&stack);
	//printf("%f %f\n\n", top (&stack).x, top (&stack).y );
    pop(&stack);
    pop(&stack);
    pop(&stack);
    
    push(&stack, 100, -1);
    

   destroyStack(&stack);
 return 0;
 }
 //
 void initStack(Stack *stack){
   (*stack).array = NULL;
    (*stack).size = 0;
    
 }
 //
 void printStack(Stack *stack){
 	for (int i = 0; i < (*stack).size; ++i){
 		printf("%f %f",stack->array[i].x, stack->array[i].y);
 		printf("\nAtstumas iki koordinaciu pradzios: %f\n\n", sqrt(stack->array[i].x*stack->array[i].x + stack->array[i].y*stack->array[i].y));
	 }
	
 }
 //
 int getStackSize (Stack *stack){
 	return (*stack).size;
 }
 //
 void push (Stack *stack, double a, double b){
 	int newSize = ((*stack).size + 1) * sizeof(Point);
 	(*stack).array = (Point *)realloc((*stack).array, newSize);
 	(*stack).size++;
 	if((*stack).array){
      stack->array[(*stack).size - 1].x = a;
      stack->array[(*stack).size - 1].y = b;
   }
 }
 //
Point top(Stack *stack){
 	Point zero;
 	zero.x = 0;
 	zero.y = 0;
 	if ((*stack).size > 0){
 	    return *((*stack).array + (*stack).size - 1);
 	}
 	else{
 		return zero;
	 }
 }
//
Point pop(Stack *stack){

    Point zero;
 	zero.x = 0;
 	zero.y = 0;
   if((*stack).size > 0){
      Point topElement = top(stack);
      int newSize = (--(*stack).size) * sizeof(Point);
      (*stack).array = (Point*)realloc((*stack).array, newSize);
      if((*stack).size == 0){
         (*stack).array = NULL;
      }
      return topElement;
   }
   return zero;
}
//
void destroyStack(Stack *stack){
    free((*stack).array);
    (*stack).size = 0;
}
 
 

